Subject: bug#52244: commiter.scm: backtrace if commit fails

From: Hartmut Goebel <[email-masked]>
Date: Thu, 2 Dec 2021 15:51:18 +0100

When commiting the change fails, committer.scm outputs a backtrace.

While one can packagers be experienced enough to understand the error 
even if it is garbled by the backtrace,
I propose suppressing it for two reasons:

1. The backtrace makes it harder to spot the actual error (since one 
needs to "parse" more text)

2. I often have issues with my guix development environment being 
instable. So when I see a backtrace from commiter.scm, I think about 
issues with my environment first - and not about an issue with git :-)

Expected
================

No backtrace, but a concise error message, like here:

$ ./pre-inst-env guile ./etc/committer.scm
gnu: python-stdnum: Update to 1.17.
* gnu/packages/finance.scm (python-stdnum): Update to 1.17.
error: gpg beim Signieren der Daten fehlgeschlagen
fatal: Fehler beim Schreiben des Commit-Objektes.
etc/committer.scm:399:24: Cannot commit

Reproduce
=================

There might be other ways to trigger a failing "git commit". For me it 
occured when using an outdated PGPG key for signing:

1. Configure git to use the outdated GPG key for signing, e.g.
git config --get user.signingkey 634A8DFFD3F631DF

2. use committer.scm to commit some changes:

$ ./pre-inst-env guile ./etc/committer.scm
gnu: python-stdnum: Update to 1.17.
* gnu/packages/finance.scm (python-stdnum): Update to 1.17.
error: gpg beim Signieren der Daten fehlgeschlagen
fatal: Fehler beim Schreiben des Commit-Objektes.
Backtrace:
In ice-9/boot-9.scm:
  1752:10  7 (with-exception-handler _ _ #:unwind? _ # _)
In unknown file:
           6 (apply-smob/0 #<thunk 7f47664f5f60>)
In ice-9/boot-9.scm:
    724:2  5 (call-with-prompt _ _ #<procedure default-prompt-handle…>)
In ice-9/eval.scm:
    619:8  4 (_ #(#(#<directory (guile-user) 7f47664efc80>)))
In ice-9/boot-9.scm:
   2835:4  3 (save-module-excursion _)
  4380:12  2 (_)
In srfi/srfi-1.scm:
    634:9  1 (for-each #<procedure 7f47648b19a0 at etc/committer.sc…> …)
In etc/committer.scm:
   399:24  0 (_ _)
etc/committer.scm:399:24: Cannot commit

-- 
Regards
Hartmut Goebel

| Hartmut Goebel          | [email-masked]               |
| www.crazy-compilers.com | compilers which you thought are impossible |